import re
from enum import Enum

# from .models import (
#     BudgetTypeEnum,
#     TravelPartyCompositionEnum,
# )

DEFAULT_LANGUAGE = "es"

MODEL_TABLE = "model"

UID_TYPE = str

KIND_KEY = "kind__"
METHOD_KEY = "method__"
FUNC_KEY = "func__"
BODY_KEY = "body"

MONOTONIC_KEY = "wave__"
MONOTONIC_SINCE = "since__"
MONOTONIC_SINCE_KEY = "since_key__"
MONOTONIC_SINCE_VALUE = "since_value__"
ORG_KEY = "id__"
FORCE_SAVE = "__save"
REG_PRIVATE_KEY = r".*__$"
REG_FQID = r"((?P<table>\w+):)?(?P<uid>\w+)$"

def build_fqid(fqid, table=''):
    m = re.match(REG_FQID, str(fqid))
    if m:
        d = m.groupdict(default=table)
        return "{table}:{uid}".format_map(d)
    return table, fqid

def filter_4_compare(data, table=''):
    """Filter data to be used for comparison"""
    if data:
        result = {
            key: value
            for key, value in data.items()
            if not re.match(REG_PRIVATE_KEY, key)
        }
        # check id:
        uid = result.get("id")
        if uid is not None:
            result['id'] = build_fqid(str(uid))
    else:
        result = {}

    return result


# ----------------------------------------------------------
# enumerate helpers
# ----------------------------------------------------------
